/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables.records;


import com.flamesgroup.storage.jooq.tables.GsmChannel;

import java.util.Date;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record8;
import org.jooq.Row8;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class GsmChannelRecord extends UpdatableRecordImpl<GsmChannelRecord> implements Record8<Long, Integer, Short, Long, Boolean, Date, String, Integer> {

	private static final long serialVersionUID = -1491808114;

	/**
	 * Setter for <code>public.gsm_channel.id</code>.
	 */
	public GsmChannelRecord setId(Long value) {
		setValue(0, value);
		return this;
	}

	/**
	 * Getter for <code>public.gsm_channel.id</code>.
	 */
	public Long getId() {
		return (Long) getValue(0);
	}

	/**
	 * Setter for <code>public.gsm_channel.device_uid</code>.
	 */
	public GsmChannelRecord setDeviceUid(Integer value) {
		setValue(1, value);
		return this;
	}

	/**
	 * Getter for <code>public.gsm_channel.device_uid</code>.
	 */
	public Integer getDeviceUid() {
		return (Integer) getValue(1);
	}

	/**
	 * Setter for <code>public.gsm_channel.channel_num</code>.
	 */
	public GsmChannelRecord setChannelNum(Short value) {
		setValue(2, value);
		return this;
	}

	/**
	 * Getter for <code>public.gsm_channel.channel_num</code>.
	 */
	public Short getChannelNum() {
		return (Short) getValue(2);
	}

	/**
	 * Setter for <code>public.gsm_channel.gsm_group_id</code>.
	 */
	public GsmChannelRecord setGsmGroupId(Long value) {
		setValue(3, value);
		return this;
	}

	/**
	 * Getter for <code>public.gsm_channel.gsm_group_id</code>.
	 */
	public Long getGsmGroupId() {
		return (Long) getValue(3);
	}

	/**
	 * Setter for <code>public.gsm_channel.lock</code>.
	 */
	public GsmChannelRecord setLock(Boolean value) {
		setValue(4, value);
		return this;
	}

	/**
	 * Getter for <code>public.gsm_channel.lock</code>.
	 */
	public Boolean getLock() {
		return (Boolean) getValue(4);
	}

	/**
	 * Setter for <code>public.gsm_channel.lock_time</code>.
	 */
	public GsmChannelRecord setLockTime(Date value) {
		setValue(5, value);
		return this;
	}

	/**
	 * Getter for <code>public.gsm_channel.lock_time</code>.
	 */
	public Date getLockTime() {
		return (Date) getValue(5);
	}

	/**
	 * Setter for <code>public.gsm_channel.lock_reason</code>.
	 */
	public GsmChannelRecord setLockReason(String value) {
		setValue(6, value);
		return this;
	}

	/**
	 * Getter for <code>public.gsm_channel.lock_reason</code>.
	 */
	public String getLockReason() {
		return (String) getValue(6);
	}

	/**
	 * Setter for <code>public.gsm_channel.lock_arfcn</code>.
	 */
	public GsmChannelRecord setLockArfcn(Integer value) {
		setValue(7, value);
		return this;
	}

	/**
	 * Getter for <code>public.gsm_channel.lock_arfcn</code>.
	 */
	public Integer getLockArfcn() {
		return (Integer) getValue(7);
	}

	// -------------------------------------------------------------------------
	// Primary key information
	// -------------------------------------------------------------------------

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Record1<Long> key() {
		return (Record1) super.key();
	}

	// -------------------------------------------------------------------------
	// Record8 type implementation
	// -------------------------------------------------------------------------

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Row8<Long, Integer, Short, Long, Boolean, Date, String, Integer> fieldsRow() {
		return (Row8) super.fieldsRow();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Row8<Long, Integer, Short, Long, Boolean, Date, String, Integer> valuesRow() {
		return (Row8) super.valuesRow();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Long> field1() {
		return GsmChannel.GSM_CHANNEL.ID;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Integer> field2() {
		return GsmChannel.GSM_CHANNEL.DEVICE_UID;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Short> field3() {
		return GsmChannel.GSM_CHANNEL.CHANNEL_NUM;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Long> field4() {
		return GsmChannel.GSM_CHANNEL.GSM_GROUP_ID;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Boolean> field5() {
		return GsmChannel.GSM_CHANNEL.LOCK;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Date> field6() {
		return GsmChannel.GSM_CHANNEL.LOCK_TIME;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<String> field7() {
		return GsmChannel.GSM_CHANNEL.LOCK_REASON;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Integer> field8() {
		return GsmChannel.GSM_CHANNEL.LOCK_ARFCN;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Long value1() {
		return getId();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Integer value2() {
		return getDeviceUid();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Short value3() {
		return getChannelNum();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Long value4() {
		return getGsmGroupId();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Boolean value5() {
		return getLock();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Date value6() {
		return getLockTime();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String value7() {
		return getLockReason();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Integer value8() {
		return getLockArfcn();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public GsmChannelRecord value1(Long value) {
		setId(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public GsmChannelRecord value2(Integer value) {
		setDeviceUid(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public GsmChannelRecord value3(Short value) {
		setChannelNum(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public GsmChannelRecord value4(Long value) {
		setGsmGroupId(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public GsmChannelRecord value5(Boolean value) {
		setLock(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public GsmChannelRecord value6(Date value) {
		setLockTime(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public GsmChannelRecord value7(String value) {
		setLockReason(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public GsmChannelRecord value8(Integer value) {
		setLockArfcn(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public GsmChannelRecord values(Long value1, Integer value2, Short value3, Long value4, Boolean value5, Date value6, String value7, Integer value8) {
		value1(value1);
		value2(value2);
		value3(value3);
		value4(value4);
		value5(value5);
		value6(value6);
		value7(value7);
		value8(value8);
		return this;
	}

	// -------------------------------------------------------------------------
	// Constructors
	// -------------------------------------------------------------------------

	/**
	 * Create a detached GsmChannelRecord
	 */
	public GsmChannelRecord() {
		super(GsmChannel.GSM_CHANNEL);
	}

	/**
	 * Create a detached, initialised GsmChannelRecord
	 */
	public GsmChannelRecord(Long id, Integer deviceUid, Short channelNum, Long gsmGroupId, Boolean lock, Date lockTime, String lockReason, Integer lockArfcn) {
		super(GsmChannel.GSM_CHANNEL);

		setValue(0, id);
		setValue(1, deviceUid);
		setValue(2, channelNum);
		setValue(3, gsmGroupId);
		setValue(4, lock);
		setValue(5, lockTime);
		setValue(6, lockReason);
		setValue(7, lockArfcn);
	}
}
